#!/bin/bash

date=`date +"%s"`
MESURES="/home/claferri/bench/resa/mesures"
IMPLEM="CKASTL STL PASTEL TBB KASTL CILK"
# TEST :
#RUN=`seq 1 1 2`
RUN=`seq 1 1 30`

# On fait 30 runs pour chaque implem :
if [ -d $MESURES ]
then
  mv $MESURES $MESURES"_"$date
fi

for impl in $IMPLEM
do
  mkdir -p $MESURES/$impl
done


echo "MASTER_RUN : 30 runs pour l'implem CKASTL";
for i in $RUN #`seq 1 1 30`;
do
  ./run_ckastl.sh $i
done

echo "MASTER_RUN : 30 runs pour l'implem STL"; 
for i in $RUN #`seq 1 1 30`;
do
  ./run_stl.sh $i
done

echo "MASTER_RUN : 30 runs pour l'implem TBB";
for i in $RUN #`seq 1 1 30`;
do
  ./run_tbb.sh $i
done

echo "MASTER_RUN : 30 runs pour l'implem KASTL"; 
for i in $RUN #`seq 1 1 30`;
do
  ./run_kastl.sh $i
done

echo "MASTER_RUN : 30 runs pour l'implem PASTEL";
for i in $RUN #`seq 1 1 30`;
do
  ./run_pastel.sh $i
done

echo "MASTER_RUN : 30 runs pour l'implem CILK";
for i in $RUN #`seq 1 1 30`;
do
  ./run_cilk.sh $i
done


date=`date +"%s"`

mv $MESURES $MESURES"_"$date
